Bug 1719987 - [abrt] evolution: verify_certificate_cb(): evolution killed by SIGABRT
Summary: [abrt] evolution: verify_certificate_cb(): evolution killed by SIGABRT
Keywords:
Status: NEW
Alias: None
Product: Fedora
Classification: Fedora
Component: glib-networking
Version: 33
Hardware: x86_64
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Michael Catanzaro
QA Contact: Fedora Extras Quality Assurance
URL: https://retrace.fedoraproject.org/faf...
Whiteboard: abrt_hash:5ac31fa2ee51507fbeb9e092294...
: 1724148 1752785 1787348 1831751 1834994 1839286 1892475 1897397 1907256 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-06-12 21:30 UTC by Tadas
Modified: 2021-01-06 18:13 UTC (History)
23 users (show)

Fixed In Version: glib-networking-2.62.2-1.fc31 glib-networking-2.60.4-1.fc30
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-12-17 01:45:02 UTC
Type: ---


Attachments (Terms of Use)
File: backtrace (82.66 KB, text/plain)
2019-06-12 21:30 UTC, Tadas
no flags Details
File: cgroup (195 bytes, text/plain)
2019-06-12 21:30 UTC, Tadas
no flags Details
File: core_backtrace (47.55 KB, text/plain)
2019-06-12 21:30 UTC, Tadas
no flags Details
File: cpuinfo (1.48 KB, text/plain)
2019-06-12 21:30 UTC, Tadas
no flags Details
File: dso_list (27.57 KB, text/plain)
2019-06-12 21:30 UTC, Tadas
no flags Details
File: environ (3.65 KB, text/plain)
2019-06-12 21:30 UTC, Tadas
no flags Details
File: limits (1.29 KB, text/plain)
2019-06-12 21:30 UTC, Tadas
no flags Details
File: maps (174.59 KB, text/plain)
2019-06-12 21:31 UTC, Tadas
no flags Details
File: mountinfo (5.08 KB, text/plain)
2019-06-12 21:31 UTC, Tadas
no flags Details
File: open_fds (5.65 KB, text/plain)
2019-06-12 21:31 UTC, Tadas
no flags Details
File: proc_pid_status (1.34 KB, text/plain)
2019-06-12 21:31 UTC, Tadas
no flags Details


Links
System ID Private Priority Status Summary Last Updated
GNOME Gitlab GNOME glib-networking issues 97 0 None None None 2019-09-23 15:47:34 UTC

Description Tadas 2019-06-12 21:30:45 UTC
Version-Release number of selected component:
evolution-3.32.2-1.fc30

Additional info:
reporter:       libreport-2.10.0
backtrace_rating: 4
cmdline:        evolution
crash_function: verify_certificate_cb
executable:     /usr/bin/evolution
journald_cursor: s=f94a1f45d07340ba9f1a92084a886f84;i=49685;b=2ed67db813a14f588def09b33e24b2ca;m=1d71e308f;t=58b07be4b5b82;x=59254b7ade2b8c0e
kernel:         5.1.6-300.fc30.x86_64
rootdir:        /
runlevel:       N 5
type:           CCpp
uid:            1000

Comment 1 Tadas 2019-06-12 21:30:49 UTC
Created attachment 1579935 [details]
File: backtrace

Comment 2 Tadas 2019-06-12 21:30:50 UTC
Created attachment 1579936 [details]
File: cgroup

Comment 3 Tadas 2019-06-12 21:30:52 UTC
Created attachment 1579937 [details]
File: core_backtrace

Comment 4 Tadas 2019-06-12 21:30:54 UTC
Created attachment 1579938 [details]
File: cpuinfo

Comment 5 Tadas 2019-06-12 21:30:55 UTC
Created attachment 1579939 [details]
File: dso_list

Comment 6 Tadas 2019-06-12 21:30:57 UTC
Created attachment 1579940 [details]
File: environ

Comment 7 Tadas 2019-06-12 21:30:58 UTC
Created attachment 1579941 [details]
File: limits

Comment 8 Tadas 2019-06-12 21:31:00 UTC
Created attachment 1579942 [details]
File: maps

Comment 9 Tadas 2019-06-12 21:31:02 UTC
Created attachment 1579943 [details]
File: mountinfo

Comment 10 Tadas 2019-06-12 21:31:03 UTC
Created attachment 1579944 [details]
File: open_fds

Comment 11 Tadas 2019-06-12 21:31:05 UTC
Created attachment 1579945 [details]
File: proc_pid_status

Comment 12 Milan Crha 2019-06-13 07:15:44 UTC
Thanks for a bug report. This is crashing somewhere deep in gnutls, thus I move it there for further investigation. It would be also helpful if you could provide steps or at least the context when this happened to you and whether you are able to reproduce this. Thanks in advance.

Thread 1 (Thread 0x7fb7beffd700 (LWP 10817)):
#0  __GI_raise (sig=sig@entry=6) at ../sysdeps/unix/sysv/linux/raise.c:50
#1  0x00007fb7f0a07895 in __GI_abort () at abort.c:79
#2  0x00007fb7f3c6eb53 in g_assertion_message (domain=<optimized out>, file=<optimized out>, line=<optimized out>, func=0x7fb7d4566170 <__FUNCTION__.31924> "verify_certificate_cb", message=<optimized out>) at ../glib/gtestutils.c:2878
#3  0x00007fb7f3cca6ff in g_assertion_message_expr (domain=domain@entry=0x7fb7d456507b "GLib-Net", file=file@entry=0x7fb7d4565940 "../tls/gnutls/gtlsconnection-gnutls.c", line=line@entry=1939, func=func@entry=0x7fb7d4566170 <__FUNCTION__.31924> "verify_certificate_cb", expr=expr@entry=0x7fb7d456584a "priv->handshake_context") at ../glib/gtestutils.c:2904
#4  0x00007fb7d455ebce in verify_certificate_cb (session=<optimized out>) at ../tls/gnutls/gtlsconnection-gnutls.c:1939
#5  verify_certificate_cb (session=<optimized out>) at ../tls/gnutls/gtlsconnection-gnutls.c:1924
#6  0x00007fb7d4398cf1 in _gnutls_run_verify_callback (side=2, session=0x7fb71c006d70) at handshake.c:2847
#7  _gnutls_run_verify_callback (session=0x7fb71c006d70, side=2) at handshake.c:2813
#8  0x00007fb7d439c5d8 in handshake_client (session=0x7fb71c006d70) at handshake.c:2969
#9  gnutls_handshake (session=0x7fb71c006d70) at handshake.c:2724
#10 0x00007fb7d455e4a7 in handshake_thread (task=0x7fb7b4053d50, object=0x55e880908d50, task_data=<optimized out>, cancellable=<optimized out>) at ../tls/gnutls/gtlsconnection-gnutls.c:2051
#11 0x00007fb7f3e80927 in g_task_thread_pool_thread (thread_data=0x7fb7b4053d50, pool_data=<optimized out>) at ../gio/gtask.c:1404
#12 0x00007fb7f3ccbf14 in g_thread_pool_thread_proxy (data=<optimized out>) at ../glib/gthreadpool.c:308
#13 0x00007fb7f3ccb4e2 in g_thread_proxy (data=0x7fb73c00f850) at ../glib/gthread.c:805
#14 0x00007fb7f47fe5a2 in start_thread (arg=<optimized out>) at pthread_create.c:486
#15 0x00007fb7f0ae0303 in clone () at ../sysdeps/unix/sysv/linux/x86_64/clone.S:95

Comment 13 Anderson Sasaki 2019-07-22 13:02:04 UTC
Failure seems to happen in the certificate verification callback registered from glib-networking.

Reassigning bug for further investigation.

Comment 14 Michael Catanzaro 2019-09-23 15:47:13 UTC
*** Bug 1752785 has been marked as a duplicate of this bug. ***

Comment 15 Michael Catanzaro 2019-09-23 15:52:26 UTC
I don't know how to subscribe to glib-networking bugs. If anyone knows, that would be great. I only noticed this today because Milan reported it upstream.

Anyway, I agree this is definitely glib-networking's fault, not Evolution or GnuTLS.

Comment 16 Milan Crha 2019-12-09 17:23:45 UTC
(In reply to Michael Catanzaro from comment #15)
> I don't know how to subscribe to glib-networking bugs. If anyone knows, that
> would be great.

Maybe you figured that out already, thus just in case: Open the project URL:
https://src.fedoraproject.org/rpms/glib-networking
and there expand the "Watch" and pick the one you are interested in. 
That will do what you are looking for, I believe.

Comment 17 Michael Catanzaro 2019-12-09 20:51:21 UTC
That definitely doesn't work. I was already subscribed. :)

This page works: https://bugzilla.redhat.com/userprefs.cgi?tab=component_watch

Comment 18 Fedora Update System 2019-12-09 20:53:46 UTC
FEDORA-2019-4f2383bec6 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2019-4f2383bec6

Comment 19 Fedora Update System 2019-12-09 21:21:27 UTC
FEDORA-2019-395944db07 has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-395944db07

Comment 20 Michael Catanzaro 2019-12-09 21:22:15 UTC
I'm about 70% confident this is fixed. Please complain if you hit this bug with the update.

Comment 21 Fedora Update System 2019-12-10 18:28:05 UTC
glib-networking-2.60.4-1.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-395944db07

Comment 22 Fedora Update System 2019-12-10 18:47:24 UTC
glib-networking-2.62.2-1.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-4f2383bec6

Comment 23 Fedora Update System 2019-12-17 01:45:02 UTC
glib-networking-2.62.2-1.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.

Comment 24 Fedora Update System 2020-01-04 22:14:16 UTC
glib-networking-2.60.4-1.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.

Comment 25 Milan Crha 2020-01-06 14:23:08 UTC
*** Bug 1787348 has been marked as a duplicate of this bug. ***

Comment 26 Michael Catanzaro 2020-01-06 14:55:03 UTC
Reopening because the user in bug #1787348 already has glib-networking 2.62.2, so the bug is not fixed after all.

I have no clue how it's still happening, but I'm trying to land a major refactor for 2.64 that should obsolete this.

Comment 27 Michael Catanzaro 2020-02-04 20:10:40 UTC
*** Bug 1724148 has been marked as a duplicate of this bug. ***

Comment 28 Michael Catanzaro 2020-02-04 20:11:29 UTC
(In reply to Michael Catanzaro from comment #26)
> I have no clue how it's still happening, but I'm trying to land a major
> refactor for 2.64 that should obsolete this.

It has slipped to 2.66, sorry.

Comment 29 Davide Repetto 2020-02-12 09:04:13 UTC
Similar problem has been detected:

This crash happened while I was marking messages as SPAM in rapid succession, at a rate of about one to three messages per second.
This is something I do every day and this is the first time a crash happened.

reporter:       libreport-2.11.3
backtrace_rating: 4
cgroup:         0::/user.slice/user-1000.slice/session-2.scope
cmdline:        evolution
crash_function: g_tls_connection_base_handshake_thread_verify_certificate
executable:     /usr/bin/evolution
journald_cursor: s=2192acf3104b4e0fb3e4bc0c4656d669;i=17cc;b=da43726002ea4a9ca1928b70cd199b79;m=20f991e71d;t=59e5cc1c86b3d;x=21cdd2cd39d405a1
kernel:         5.4.17-200.fc31.x86_64
package:        evolution-3.34.3-1.fc31
reason:         evolution killed by SIGABRT
rootdir:        /
runlevel:       N 5
type:           CCpp
uid:            1000

Comment 30 Ben Cotton 2020-04-30 20:27:31 UTC
This message is a reminder that Fedora 30 is nearing its end of life.
Fedora will stop maintaining and issuing updates for Fedora 30 on 2020-05-26.
It is Fedora's policy to close all bug reports from releases that are no longer
maintained. At that time this bug will be closed as EOL if it remains open with a
Fedora 'version' of '30'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 30 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 31 Milan Crha 2020-05-06 08:08:41 UTC
*** Bug 1831751 has been marked as a duplicate of this bug. ***

Comment 32 Michael Catanzaro 2020-05-06 13:23:34 UTC
FYI this is still on my radar, I'm still hoping to remove this code in 2.64, and still don't see how it could happen.

Comment 33 Michael Catanzaro 2020-05-13 12:21:57 UTC
*** Bug 1834994 has been marked as a duplicate of this bug. ***

Comment 34 Michael Catanzaro 2020-05-13 12:22:34 UTC
From bug #1834994:

(In reply to Michael Catanzaro from comment #13)
> (In reply to Milan Crha from comment #12)
> > Michael, search the backtrace for: 0x7f42ec0147f0 . I think it's
> > suspiciously used, but I do not know glib-networking internals, thus maybe
> > it's correct (for example I do not know why it is part of the 'sorted'
> > array).
> 
> It's expected to be used on two threads at once, but it's not expected for
> it to be part of the 'sorted' array. That's messed up.

Comment 35 Michael Catanzaro 2020-05-13 12:51:45 UTC
(In reply to Michael Catanzaro from comment #34)
> It's expected to be used on two threads at once, but it's not expected for
> it to be part of the 'sorted' array. That's messed up.

So I'm fairly confident that if we were to have caught that under valgrind or asan, it would be pointing us directly to the problem. But with just a backtrace, it's impossible to know what has gone wrong. Debugging this is going to require active effort from someone who is hitting the crash to run e-d-s constantly under valgrind.

Comment 36 Milan Crha 2020-05-25 08:35:42 UTC
*** Bug 1839286 has been marked as a duplicate of this bug. ***

Comment 37 Ben Cotton 2020-08-11 13:06:20 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 33 development cycle.
Changing version to 33.

Comment 38 Milan Crha 2020-10-29 16:38:24 UTC
*** Bug 1892475 has been marked as a duplicate of this bug. ***

Comment 39 John Dodson 2020-10-31 22:01:48 UTC
This abrt event also created thousands of broken symlinks in /var/cache/abrt-di/usr/lib/debug/.build-id
which is very frustrating - that I assume is a bug in abrt? But I can't report it as it won't accept my list of thousands of broken links.

Comment 40 Milan Crha 2020-11-13 09:20:52 UTC
*** Bug 1897397 has been marked as a duplicate of this bug. ***

Comment 41 Milan Crha 2021-01-04 13:02:55 UTC
*** Bug 1907256 has been marked as a duplicate of this bug. ***


Note You need to log in before you can comment on or make changes to this bug.